/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of ODBM_File.xs. Do not edit this file, edit ODBM_File.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "ODBM_File.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef I_DBM
#  include <dbm.h>
#else
#  ifdef I_RPCSVC_DBM
#    include <rpcsvc/dbm.h>
#  endif
#endif

#ifndef HAS_DBMINIT_PROTO
int	dbminit(char* filename);
int	dbmclose(void);
datum	fetch(datum key);
int	store(datum key, datum dat);
int	delete(datum key);
datum	firstkey(void);
datum	nextkey(datum key);
#endif

#ifdef DBM_BUG_DUPLICATE_FREE 
/*
 * DBM on at least Ultrix and HPUX call dbmclose() from dbminit(),
 * resulting in duplicate free() because dbmclose() does *not*
 * check if it has already been called for this DBM.
 * If some malloc/free calls have been done between dbmclose() and
 * the next dbminit(), the memory might be used for something else when
 * it is freed.
 * Verified to work on ultrix4.3.  Probably will work on HP/UX.
 * Set DBM_BUG_DUPLICATE_FREE in the extension hint file.
 */
/* Close the previous dbm, and fail to open a new dbm */
#define dbmclose()	((void) dbminit("/tmp/x/y/z/z/y"))
#endif

#include <fcntl.h>

typedef struct {
	void * 	dbp ;
	SV *    filter_fetch_key ;
	SV *    filter_store_key ;
	SV *    filter_fetch_value ;
	SV *    filter_store_value ;
	int     filtering ;
	} ODBM_File_type;

typedef ODBM_File_type * ODBM_File ;
typedef datum datum_key ;
typedef datum datum_key_copy ;
typedef datum datum_value ;

#define odbm_FETCH(db,key)			fetch(key)
#define odbm_STORE(db,key,value,flags)		store(key,value)
#define odbm_DELETE(db,key)			delete(key)
#define odbm_FIRSTKEY(db)			firstkey()
#define odbm_NEXTKEY(db,key)			nextkey(key)

#define MY_CXT_KEY "ODBM_File::_guts" XS_VERSION

typedef struct {
    int		x_dbmrefcnt;
} my_cxt_t;

START_MY_CXT

#define dbmrefcnt	(MY_CXT.x_dbmrefcnt)

#ifndef DBM_REPLACE
#define DBM_REPLACE 0
#endif

#line 84 "ODBM_File.c"
XS(XS_ODBM_File_TIEHASH); /* prototype to pass -Wmissing-prototypes */
XS(XS_ODBM_File_TIEHASH)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: ODBM_File::TIEHASH(dbtype, filename, flags, mode)");
    {
	char *	dbtype = (char *)SvPV_nolen(ST(0));
	char *	filename = (char *)SvPV_nolen(ST(1));
	int	flags = (int)SvIV(ST(2));
	int	mode = (int)SvIV(ST(3));
	ODBM_File	RETVAL;
#line 88 "ODBM_File.xs"
	{
	    char *tmpbuf;
	    void * dbp ;
	    dMY_CXT;

	    if (dbmrefcnt++)
		croak("Old dbm can only open one database");
	    New(0, tmpbuf, strlen(filename) + 5, char);
	    SAVEFREEPV(tmpbuf);
	    sprintf(tmpbuf,"%s.dir",filename);
	    if (stat(tmpbuf, &PL_statbuf) < 0) {
		if (flags & O_CREAT) {
		    if (mode < 0 || close(creat(tmpbuf,mode)) < 0)
			croak("ODBM_File: Can't create %s", filename);
		    sprintf(tmpbuf,"%s.pag",filename);
		    if (close(creat(tmpbuf,mode)) < 0)
			croak("ODBM_File: Can't create %s", filename);
		}
		else
		    croak("ODBM_FILE: Can't open %s", filename);
	    }
	    dbp = (void*)(dbminit(filename) >= 0 ? &dbmrefcnt : 0);
	    RETVAL = (ODBM_File)safemalloc(sizeof(ODBM_File_type)) ;
    	    Zero(RETVAL, 1, ODBM_File_type) ;
	    RETVAL->dbp = dbp ;
	    ST(0) = sv_mortalcopy(&PL_sv_undef);
	    sv_setptrobj(ST(0), RETVAL, dbtype);
	}
#line 126 "ODBM_File.c"
    }
    XSRETURN(1);
}

XS(XS_ODBM_File_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_ODBM_File_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: ODBM_File::DESTROY(db)");
    {
	ODBM_File	db;
#line 121 "ODBM_File.xs"
	dMY_CXT;
#line 141 "ODBM_File.c"

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(ODBM_File,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not a reference");
#line 123 "ODBM_File.xs"
	dbmrefcnt--;
	dbmclose();
	safefree(db);
#line 153 "ODBM_File.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_ODBM_File_FETCH); /* prototype to pass -Wmissing-prototypes */
XS(XS_ODBM_File_FETCH)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: ODBM_File::FETCH(db, key)");
    {
	ODBM_File	db;
	datum_key_copy	key;
	datum_value	RETVAL;

	if (sv_derived_from(ST(0), "ODBM_File")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(ODBM_File,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type ODBM_File");

	{
	    SV * tmpSV ;
	    if (db->filter_store_key){
	        tmpSV = sv_2mortal(newSVsv(ST(1)));
	        DBM_ckFilter(tmpSV, filter_store_key, "filter_store_key");
	    }
	    else
		tmpSV = ST(1);
	    key.dptr = SvPV(tmpSV, PL_na);
	    key.dsize = (int)PL_na;
	};

	RETVAL = odbm_FETCH(db, key);
	ST(0) = sv_newmortal();
	sv_setpvn(ST(0), RETVAL.dptr, RETVAL.dsize);
	DBM_ckFilter(ST(0), filter_fetch_value,"filter_fetch_value");
    }
    XSRETURN(1);
}

XS(XS_ODBM_File_STORE); /* prototype to pass -Wmissing-prototypes */
XS(XS_ODBM_File_STORE)
{
    dXSARGS;
    if (items < 3 || items > 4)
	Perl_croak(aTHX_ "Usage: ODBM_File::STORE(db, key, value, flags = DBM_REPLACE)");
    {
	ODBM_File	db;
	datum_key	key;
	datum_value	value;
	int	flags;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "ODBM_File")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(ODBM_File,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type ODBM_File");

	DBM_ckFilter(ST(1), filter_store_key, "filter_store_key");
	key.dptr = SvPV(ST(1), PL_na);
	key.dsize = (int)PL_na;

        DBM_ckFilter(ST(2), filter_store_value, "filter_store_value");
	if (SvOK(ST(2))) {
	    value.dptr = SvPV(ST(2), PL_na);
	    value.dsize = (int)PL_na;
	}
	else {
	    value.dptr = "";
	    value.dsize = 0;
	};

	if (items < 4)
	    flags = DBM_REPLACE;
	else {
	    flags = (int)SvIV(ST(3));
	}

	RETVAL = odbm_STORE(db, key, value, flags);
	XSprePUSH; PUSHi((IV)RETVAL);
#line 139 "ODBM_File.xs"
	if (RETVAL) {
	    if (RETVAL < 0 && errno == EPERM)
		croak("No write permission to odbm file");
	    croak("odbm store returned %d, errno %d, key \"%s\"",
			RETVAL,errno,key.dptr);
	}
#line 246 "ODBM_File.c"
    }
    XSRETURN(1);
}

XS(XS_ODBM_File_DELETE); /* prototype to pass -Wmissing-prototypes */
XS(XS_ODBM_File_DELETE)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: ODBM_File::DELETE(db, key)");
    {
	ODBM_File	db;
	datum_key	key;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "ODBM_File")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(ODBM_File,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type ODBM_File");

	DBM_ckFilter(ST(1), filter_store_key, "filter_store_key");
	key.dptr = SvPV(ST(1), PL_na);
	key.dsize = (int)PL_na;

	RETVAL = odbm_DELETE(db, key);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_ODBM_File_FIRSTKEY); /* prototype to pass -Wmissing-prototypes */
XS(XS_ODBM_File_FIRSTKEY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: ODBM_File::FIRSTKEY(db)");
    {
	ODBM_File	db;
	datum_key	RETVAL;

	if (sv_derived_from(ST(0), "ODBM_File")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(ODBM_File,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type ODBM_File");

	RETVAL = odbm_FIRSTKEY(db);
	ST(0) = sv_newmortal();
	sv_setpvn(ST(0), RETVAL.dptr, RETVAL.dsize);
	DBM_ckFilter(ST(0), filter_fetch_key,"filter_fetch_key");
    }
    XSRETURN(1);
}

XS(XS_ODBM_File_NEXTKEY); /* prototype to pass -Wmissing-prototypes */
XS(XS_ODBM_File_NEXTKEY)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: ODBM_File::NEXTKEY(db, key)");
    {
	ODBM_File	db;
	datum_key	key;
	datum_key	RETVAL;

	if (sv_derived_from(ST(0), "ODBM_File")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(ODBM_File,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type ODBM_File");

	DBM_ckFilter(ST(1), filter_store_key, "filter_store_key");
	key.dptr = SvPV(ST(1), PL_na);
	key.dsize = (int)PL_na;

	RETVAL = odbm_NEXTKEY(db, key);
	ST(0) = sv_newmortal();
	sv_setpvn(ST(0), RETVAL.dptr, RETVAL.dsize);
	DBM_ckFilter(ST(0), filter_fetch_key,"filter_fetch_key");
    }
    XSRETURN(1);
}

#define setFilter(type)					\
	{						\
	    if (db->type)				\
	        RETVAL = sv_mortalcopy(db->type) ; 	\
	    ST(0) = RETVAL ;				\
	    if (db->type && (code == &PL_sv_undef)) {	\
                SvREFCNT_dec(db->type) ;		\
	        db->type = Nullsv ;			\
	    }						\
	    else if (code) {				\
	        if (db->type)				\
	            sv_setsv(db->type, code) ;		\
	        else					\
	            db->type = newSVsv(code) ;		\
	    }	    					\
	}
XS(XS_ODBM_File_filter_fetch_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_ODBM_File_filter_fetch_key)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: ODBM_File::filter_fetch_key(db, code)");
    {
	ODBM_File	db;
	SV *	code = ST(1);
	SV *	RETVAL = &PL_sv_undef ;

	if (sv_derived_from(ST(0), "ODBM_File")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(ODBM_File,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type ODBM_File");
#line 186 "ODBM_File.xs"
	    DBM_setFilter(db->filter_fetch_key, code) ;
#line 370 "ODBM_File.c"
    }
    XSRETURN(1);
}

XS(XS_ODBM_File_filter_store_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_ODBM_File_filter_store_key)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: ODBM_File::filter_store_key(db, code)");
    {
	ODBM_File	db;
	SV *	code = ST(1);
	SV *	RETVAL =  &PL_sv_undef ;

	if (sv_derived_from(ST(0), "ODBM_File")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(ODBM_File,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type ODBM_File");
#line 194 "ODBM_File.xs"
	    DBM_setFilter(db->filter_store_key, code) ;
#line 394 "ODBM_File.c"
    }
    XSRETURN(1);
}

XS(XS_ODBM_File_filter_fetch_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_ODBM_File_filter_fetch_value)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: ODBM_File::filter_fetch_value(db, code)");
    {
	ODBM_File	db;
	SV *	code = ST(1);
	SV *	RETVAL =  &PL_sv_undef ;

	if (sv_derived_from(ST(0), "ODBM_File")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(ODBM_File,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type ODBM_File");
#line 202 "ODBM_File.xs"
	    DBM_setFilter(db->filter_fetch_value, code) ;
#line 418 "ODBM_File.c"
    }
    XSRETURN(1);
}

XS(XS_ODBM_File_filter_store_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_ODBM_File_filter_store_value)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: ODBM_File::filter_store_value(db, code)");
    {
	ODBM_File	db;
	SV *	code = ST(1);
	SV *	RETVAL =  &PL_sv_undef ;

	if (sv_derived_from(ST(0), "ODBM_File")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(ODBM_File,tmp);
	}
	else
	    Perl_croak(aTHX_ "db is not of type ODBM_File");
#line 210 "ODBM_File.xs"
	    DBM_setFilter(db->filter_store_value, code) ;
#line 442 "ODBM_File.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_ODBM_File); /* prototype to pass -Wmissing-prototypes */
XS(boot_ODBM_File)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXS("ODBM_File::TIEHASH", XS_ODBM_File_TIEHASH, file);
        newXS("ODBM_File::DESTROY", XS_ODBM_File_DESTROY, file);
        newXS("ODBM_File::FETCH", XS_ODBM_File_FETCH, file);
        newXS("ODBM_File::STORE", XS_ODBM_File_STORE, file);
        newXS("ODBM_File::DELETE", XS_ODBM_File_DELETE, file);
        newXS("ODBM_File::FIRSTKEY", XS_ODBM_File_FIRSTKEY, file);
        newXS("ODBM_File::NEXTKEY", XS_ODBM_File_NEXTKEY, file);
        newXS("ODBM_File::filter_fetch_key", XS_ODBM_File_filter_fetch_key, file);
        newXS("ODBM_File::filter_store_key", XS_ODBM_File_filter_store_key, file);
        newXS("ODBM_File::filter_fetch_value", XS_ODBM_File_filter_fetch_value, file);
        newXS("ODBM_File::filter_store_value", XS_ODBM_File_filter_store_value, file);

    /* Initialisation Section */

#line 77 "ODBM_File.xs"
{
    MY_CXT_INIT;
}

#line 477 "ODBM_File.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

